import{S as qn,i as Cn,s as Tn,e as s,k as p,w as f,t as r,M as Pn,c as l,d as a,m as d,a as n,x as u,h as o,b as h,G as t,g as c,y as m,q as _,o as g,B as v,v as In}from"../../chunks/vendor-hf-doc-builder.js";import{T as On}from"../../chunks/Tip-hf-doc-builder.js";import{I as ca}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as b}from"../../chunks/CodeBlock-hf-doc-builder.js";function xn(pa){let k;return{c(){k=r(`Trackers built in Accelerate will automatically execute on the correct process, 
  so if a tracker is only meant to be ran on the main process it will do so 
  automatically.`)},l(C){k=o(C,`Trackers built in Accelerate will automatically execute on the correct process, 
  so if a tracker is only meant to be ran on the main process it will do so 
  automatically.`)},m(C,q){c(C,k,q)},d(C){C&&a(k)}}}function Dn(pa){let k,C,q,W,lt,ae,yr,nt,kr,da,re,br,ze,$r,ha,L,U,it,oe,Er,ct,Ar,fa,F,jr,pt,qr,Cr,ua,$,dt,Tr,Pr,ht,Ir,Or,ft,xr,Dr,ut,Lr,ma,T,Sr,mt,zr,Nr,_t,Br,Mr,_a,se,ga,G,Wr,Ne,Ur,Fr,va,le,wa,P,Gr,Be,Rr,Hr,gt,Jr,Kr,ya,ne,ka,R,Qr,Me,Vr,Xr,ba,ie,$a,We,Yr,Ea,ce,Aa,w,Zr,vt,eo,to,wt,ao,ro,yt,oo,so,kt,lo,no,Ue,io,co,ja,pe,qa,S,H,bt,de,po,$t,ho,Ca,I,fo,Et,uo,mo,At,_o,go,Ta,y,he,Fe,jt,vo,wo,yo,fe,ue,ko,qt,bo,$o,Eo,me,Ao,Ct,jo,qo,Co,_e,Ge,Tt,To,Po,Io,Pt,ge,Oo,It,xo,Do,Lo,ve,Re,Ot,So,zo,No,xt,z,Bo,Dt,Mo,Wo,Lt,Uo,Fo,Go,we,J,St,Ro,Ho,zt,Jo,Ko,Qo,ye,ke,Vo,Nt,Xo,Yo,Zo,Bt,es,ts,be,K,Mt,as,rs,Wt,os,ss,ls,Ut,$e,ns,Ft,is,cs,ps,Ee,He,Gt,ds,hs,fs,Ae,je,us,Rt,ms,_s,gs,N,vs,Ht,ws,ys,Jt,ks,bs,Pa,Q,$s,Je,Es,As,Ia,Ke,js,Oa,qe,xa,E,qs,Kt,Cs,Ts,Qt,Ps,Is,Vt,Os,xs,Da,Ce,La,V,Ds,Xt,Ls,Ss,Sa,Te,za,B,X,Yt,Pe,zs,Zt,Ns,Na,O,Bs,Qe,Ms,Ws,ea,Us,Fs,Ba,Ve,Gs,Ma,Ie,Wa,x,Rs,ta,Hs,Js,aa,Ks,Qs,Ua,Oe,Fa,Y,Ga,Xe,Vs,Ra,xe,Ha,M,Z,ra,De,Xs,oa,Ys,Ja,D,Zs,sa,el,tl,la,al,rl,Ka,Le,Qa;return ae=new ca({}),oe=new ca({}),se=new b({props:{code:`from accelerate import Accelerator
from accelerate.utils import LoggerType

accelerator = Accelerator(log_with="all")  # For all available trackers in the environment
accelerator = Accelerator(log_with="wandb")
accelerator = Accelerator(log_with=["wandb", LoggerType.TENSORBOARD])`,highlighted:`<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator
<span class="hljs-keyword">from</span> accelerate.utils <span class="hljs-keyword">import</span> LoggerType

accelerator = Accelerator(log_with=<span class="hljs-string">&quot;all&quot;</span>)  <span class="hljs-comment"># For all available trackers in the environment</span>
accelerator = Accelerator(log_with=<span class="hljs-string">&quot;wandb&quot;</span>)
accelerator = Accelerator(log_with=[<span class="hljs-string">&quot;wandb&quot;</span>, LoggerType.TENSORBOARD])`}}),le=new b({props:{code:`hps = {"num_iterations": 5, "learning_rate": 1e-2}
accelerator.init_trackers("my_project", config=hps)`,highlighted:`hps = {<span class="hljs-string">&quot;num_iterations&quot;</span>: <span class="hljs-number">5</span>, <span class="hljs-string">&quot;learning_rate&quot;</span>: <span class="hljs-number">1e-2</span>}
accelerator.init_trackers(<span class="hljs-string">&quot;my_project&quot;</span>, config=hps)`}}),ne=new b({props:{code:'accelerator.log({"train_loss": 1.12, "valid_loss": 0.8}, step=1)',highlighted:'accelerator.log({<span class="hljs-string">&quot;train_loss&quot;</span>: <span class="hljs-number">1.12</span>, <span class="hljs-string">&quot;valid_loss&quot;</span>: <span class="hljs-number">0.8</span>}, step=<span class="hljs-number">1</span>)'}}),ie=new b({props:{code:"accelerator.end_training()",highlighted:"accelerator.end_training()"}}),ce=new b({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(log_with="all")
config = {
    "num_iterations": 5,
    "learning_rate": 1e-2,
    "loss_function": str(my_loss_function),
}

accelerator.init_trackers("example_project", config=config)

my_model, my_optimizer, my_training_dataloader = accelerate.prepare(my_model, my_optimizer, my_training_dataloader)
device = accelerator.device
my_model.to(device)

for iteration in config["num_iterations"]:
    for step, batch in my_training_dataloader:
        my_optimizer.zero_grad()
        inputs, targets = batch
        inputs = inputs.to(device)
        targets = targets.to(device)
        outputs = my_model(inputs)
        loss = my_loss_function(outputs, targets)
        accelerator.backward(loss)
        my_optimizer.step()
        accelerator.log({"training_loss": loss}, step=step)
accelerator.end_training()`,highlighted:`<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

accelerator = Accelerator(log_with=<span class="hljs-string">&quot;all&quot;</span>)
config = {
    <span class="hljs-string">&quot;num_iterations&quot;</span>: <span class="hljs-number">5</span>,
    <span class="hljs-string">&quot;learning_rate&quot;</span>: <span class="hljs-number">1e-2</span>,
    <span class="hljs-string">&quot;loss_function&quot;</span>: <span class="hljs-built_in">str</span>(my_loss_function),
}

accelerator.init_trackers(<span class="hljs-string">&quot;example_project&quot;</span>, config=config)

my_model, my_optimizer, my_training_dataloader = accelerate.prepare(my_model, my_optimizer, my_training_dataloader)
device = accelerator.device
my_model.to(device)

<span class="hljs-keyword">for</span> iteration <span class="hljs-keyword">in</span> config[<span class="hljs-string">&quot;num_iterations&quot;</span>]:
    <span class="hljs-keyword">for</span> step, batch <span class="hljs-keyword">in</span> my_training_dataloader:
        my_optimizer.zero_grad()
        inputs, targets = batch
        inputs = inputs.to(device)
        targets = targets.to(device)
        outputs = my_model(inputs)
        loss = my_loss_function(outputs, targets)
        accelerator.backward(loss)
        my_optimizer.step()
        accelerator.log({<span class="hljs-string">&quot;training_loss&quot;</span>: loss}, step=step)
accelerator.end_training()`}}),pe=new b({props:{code:'accelerator = Accelerator(log_with="tensorboard", logging_dir=".")',highlighted:'accelerator = Accelerator(log_with=<span class="hljs-string">&quot;tensorboard&quot;</span>, logging_dir=<span class="hljs-string">&quot;.&quot;</span>)'}}),de=new ca({}),qe=new b({props:{code:`from accelerate.tracking import GeneralTracker, on_main_process
from typing import Optional

import wandb


class MyCustomTracker(GeneralTracker):
    name = "wandb"
    requires_logging_directory = False

    @on_main_process
    def __init__(self, run_name: str):
        self.run_name = run_name
        run = wandb.init(self.run_name)

    @property
    def tracker(self):
        return self.run.run

    @on_main_process
    def store_init_configuration(self, values: dict):
        wandb.config(values)

    @on_main_process
    def log(self, values: dict, step: Optional[int] = None):
        wandb.log(values, step=step)`,highlighted:`<span class="hljs-keyword">from</span> accelerate.tracking <span class="hljs-keyword">import</span> GeneralTracker, on_main_process
<span class="hljs-keyword">from</span> typing <span class="hljs-keyword">import</span> <span class="hljs-type">Optional</span>

<span class="hljs-keyword">import</span> wandb


<span class="hljs-keyword">class</span> <span class="hljs-title class_">MyCustomTracker</span>(<span class="hljs-title class_ inherited__">GeneralTracker</span>):
    name = <span class="hljs-string">&quot;wandb&quot;</span>
    requires_logging_directory = <span class="hljs-literal">False</span>

<span class="hljs-meta">    @on_main_process</span>
    <span class="hljs-keyword">def</span> <span class="hljs-title function_">__init__</span>(<span class="hljs-params">self, run_name: <span class="hljs-built_in">str</span></span>):
        self.run_name = run_name
        run = wandb.init(self.run_name)

<span class="hljs-meta">    @property</span>
    <span class="hljs-keyword">def</span> <span class="hljs-title function_">tracker</span>(<span class="hljs-params">self</span>):
        <span class="hljs-keyword">return</span> self.run.run

<span class="hljs-meta">    @on_main_process</span>
    <span class="hljs-keyword">def</span> <span class="hljs-title function_">store_init_configuration</span>(<span class="hljs-params">self, values: <span class="hljs-built_in">dict</span></span>):
        wandb.config(values)

<span class="hljs-meta">    @on_main_process</span>
    <span class="hljs-keyword">def</span> <span class="hljs-title function_">log</span>(<span class="hljs-params">self, values: <span class="hljs-built_in">dict</span>, step: <span class="hljs-type">Optional</span>[<span class="hljs-built_in">int</span>] = <span class="hljs-literal">None</span></span>):
        wandb.log(values, step=step)`}}),Ce=new b({props:{code:`tracker = MyCustomTracker("some_run_name")
accelerator = Accelerator(log_with=tracker)`,highlighted:`tracker = MyCustomTracker(<span class="hljs-string">&quot;some_run_name&quot;</span>)
accelerator = Accelerator(log_with=tracker)`}}),Te=new b({props:{code:`tracker = MyCustomTracker("some_run_name")
accelerator = Accelerator(log_with=[tracker, "all"])`,highlighted:`tracker = MyCustomTracker(<span class="hljs-string">&quot;some_run_name&quot;</span>)
accelerator = Accelerator(log_with=[tracker, <span class="hljs-string">&quot;all&quot;</span>])`}}),Pe=new ca({}),Ie=new b({props:{code:'wandb_tracker = accelerator.get_tracker("wandb")',highlighted:'wandb_tracker = accelerator.get_tracker(<span class="hljs-string">&quot;wandb&quot;</span>)'}}),Oe=new b({props:{code:"wandb_run.log_artifact(some_artifact_to_log)",highlighted:"wandb_run.log_artifact(some_artifact_to_log)"}}),Y=new On({props:{$$slots:{default:[xn]},$$scope:{ctx:pa}}}),xe=new b({props:{code:`wandb_tracker = accelerator.get_tracker("wandb", unwrap=True)
with accelerator.on_main_process:
    wandb_tracker.log_artifact(some_artifact_to_log)`,highlighted:`wandb_tracker = accelerator.get_tracker(<span class="hljs-string">&quot;wandb&quot;</span>, unwrap=<span class="hljs-literal">True</span>)
<span class="hljs-keyword">with</span> accelerator.on_main_process:
    wandb_tracker.log_artifact(some_artifact_to_log)`}}),De=new ca({}),Le=new b({props:{code:`  from accelerate import Accelerator
+ import neptune.new as neptune

  accelerator = Accelerator()
+ run = neptune.init(...)

  my_model, my_optimizer, my_training_dataloader = accelerate.prepare(my_model, my_optimizer, my_training_dataloader)
  device = accelerator.device
  my_model.to(device)

  for iteration in config["num_iterations"]:
      for batch in my_training_dataloader:
          my_optimizer.zero_grad()
          inputs, targets = batch
          inputs = inputs.to(device)
          targets = targets.to(device)
          outputs = my_model(inputs)
          loss = my_loss_function(outputs, targets)
          total_loss += loss
          accelerator.backward(loss)
          my_optimizer.step()
+         if accelerator.is_main_process:
+             run["logs/training/batch/loss"].log(loss)`,highlighted:`  from accelerate import Accelerator
<span class="hljs-addition">+ import neptune.new as neptune</span>

  accelerator = Accelerator()
<span class="hljs-addition">+ run = neptune.init(...)</span>

  my_model, my_optimizer, my_training_dataloader = accelerate.prepare(my_model, my_optimizer, my_training_dataloader)
  device = accelerator.device
  my_model.to(device)

  for iteration in config[&quot;num_iterations&quot;]:
      for batch in my_training_dataloader:
          my_optimizer.zero_grad()
          inputs, targets = batch
          inputs = inputs.to(device)
          targets = targets.to(device)
          outputs = my_model(inputs)
          loss = my_loss_function(outputs, targets)
          total_loss += loss
          accelerator.backward(loss)
          my_optimizer.step()
<span class="hljs-addition">+         if accelerator.is_main_process:</span>
<span class="hljs-addition">+             run[&quot;logs/training/batch/loss&quot;].log(loss)</span>`}}),{c(){k=s("meta"),C=p(),q=s("h1"),W=s("a"),lt=s("span"),f(ae.$$.fragment),yr=p(),nt=s("span"),kr=r("Tracking"),da=p(),re=s("p"),br=r(`There are a large number of experiment tracking API\u2019s available, however getting them all to work with in a multi-processing environment can oftentimes be complex.
\u{1F917} Accelerate provides a general tracking API that can be used to log useful items during your script through `),ze=s("a"),$r=r("Accelerator.log()"),ha=p(),L=s("h2"),U=s("a"),it=s("span"),f(oe.$$.fragment),Er=p(),ct=s("span"),Ar=r("Integrated Trackers"),fa=p(),F=s("p"),jr=r("Currently "),pt=s("code"),qr=r("Accelerate"),Cr=r(" supports four trackers out-of-the-box:"),ua=p(),$=s("ul"),dt=s("li"),Tr=r("TensorBoard"),Pr=p(),ht=s("li"),Ir=r("WandB"),Or=p(),ft=s("li"),xr=r("CometML"),Dr=p(),ut=s("li"),Lr=r("MLFlow"),ma=p(),T=s("p"),Sr=r("To use any of them, pass in the selected type(s) to the "),mt=s("code"),zr=r("log_with"),Nr=r(" parameter in "),_t=s("code"),Br=r("Accelerate"),Mr=r(":"),_a=p(),f(se.$$.fragment),ga=p(),G=s("p"),Wr=r("At the start of your experiment "),Ne=s("a"),Ur=r("Accelerator.init_trackers()"),Fr=r(" should be used to setup your project, and potentially add any experiment hyperparameters to be logged:"),va=p(),f(le.$$.fragment),wa=p(),P=s("p"),Gr=r("When you are ready to log any data, "),Be=s("a"),Rr=r("Accelerator.log()"),Hr=r(` should be used.
A `),gt=s("code"),Jr=r("step"),Kr=r(" can also be passed in to correlate the data with a particular step in the training loop."),ya=p(),f(ne.$$.fragment),ka=p(),R=s("p"),Qr=r("Once you\u2019ve finished training, make sure to run "),Me=s("a"),Vr=r("Accelerator.end_training()"),Xr=r(" so that all the trackers can run their finish functionalities if they have any."),ba=p(),f(ie.$$.fragment),$a=p(),We=s("p"),Yr=r("A full example is below:"),Ea=p(),f(ce.$$.fragment),Aa=p(),w=s("p"),Zr=r("If a tracker requires a directory to save data to such as "),vt=s("code"),eo=r("TensorBoard"),to=r(" then a "),wt=s("code"),ao=r("logging_dir"),ro=r(" or "),yt=s("code"),oo=r("project_dir"),so=r(" can be passed in. "),kt=s("code"),lo=r("project_dir"),no=r(` is useful
if there are other further configurations such as those which can be combined with the `),Ue=s("a"),io=r("ProjectConfiguration"),co=r(" dataclass."),ja=p(),f(pe.$$.fragment),qa=p(),S=s("h2"),H=s("a"),bt=s("span"),f(de.$$.fragment),po=p(),$t=s("span"),ho=r("Implementing Custom Trackers"),Ca=p(),I=s("p"),fo=r("To implement a new tracker to be used in "),Et=s("code"),uo=r("Accelerator"),mo=r(", a new one can be made through implementing the "),At=s("code"),_o=r("GeneralTracker"),go=r(` class.
Every tracker must implement three functions and have three properties:`),Ta=p(),y=s("ul"),he=s("li"),Fe=s("p"),jt=s("code"),vo=r("__init__"),wo=r(":"),yo=p(),fe=s("ul"),ue=s("li"),ko=r("Should store a "),qt=s("code"),bo=r("run_name"),$o=r(" and initialize the tracker API of the integrated library."),Eo=p(),me=s("li"),Ao=r("If a tracker stores their data locally (such as TensorBoard), a "),Ct=s("code"),jo=r("logging_dir"),qo=r(" parameter can be added."),Co=p(),_e=s("li"),Ge=s("p"),Tt=s("code"),To=r("store_init_configuration"),Po=r(":"),Io=p(),Pt=s("ul"),ge=s("li"),Oo=r("Should take in a "),It=s("code"),xo=r("values"),Do=r(" dictionary and store them as a one-time experiment configuration"),Lo=p(),ve=s("li"),Re=s("p"),Ot=s("code"),So=r("log"),zo=r(":"),No=p(),xt=s("ul"),z=s("li"),Bo=r("Should take in a "),Dt=s("code"),Mo=r("values"),Wo=r(" dictionary and a "),Lt=s("code"),Uo=r("step"),Fo=r(", and should log them to the run"),Go=p(),we=s("li"),J=s("p"),St=s("code"),Ro=r("name"),Ho=r(" ("),zt=s("code"),Jo=r("str"),Ko=r("):"),Qo=p(),ye=s("ul"),ke=s("li"),Vo=r("A unique string name for the tracker, such as "),Nt=s("code"),Xo=r('"wandb"'),Yo=r(" for the wandb tracker."),Zo=p(),Bt=s("li"),es=r("This will be used for interacting with this tracker specifically"),ts=p(),be=s("li"),K=s("p"),Mt=s("code"),as=r("requires_logging_directory"),rs=r(" ("),Wt=s("code"),os=r("bool"),ss=r("):"),ls=p(),Ut=s("ul"),$e=s("li"),ns=r("Whether a "),Ft=s("code"),is=r("logging_dir"),cs=r(" is needed for this particular tracker and if it uses one."),ps=p(),Ee=s("li"),He=s("p"),Gt=s("code"),ds=r("tracker"),hs=r(":"),fs=p(),Ae=s("ul"),je=s("li"),us=r("This should be implemented as a "),Rt=s("code"),ms=r("@property"),_s=r(" function"),gs=p(),N=s("li"),vs=r("Should return the internal tracking mechanism the library uses, such as the "),Ht=s("code"),ws=r("run"),ys=r(" object for "),Jt=s("code"),ks=r("wandb"),bs=r("."),Pa=p(),Q=s("p"),$s=r("Each method should also utilize the "),Je=s("a"),Es=r("state.PartialState"),As=r(" class if the logger should only be executed on the main process for instance."),Ia=p(),Ke=s("p"),js=r(`A brief example can be seen below with an integration with Weights and Biases, containing only the relevant information and logging just on
the main process:`),Oa=p(),f(qe.$$.fragment),xa=p(),E=s("p"),qs=r("When you are ready to build your "),Kt=s("code"),Cs=r("Accelerator"),Ts=r(" object, pass in an "),Qt=s("strong"),Ps=r("instance"),Is=r(" of your tracker to "),Vt=s("code"),Os=r("Accelerator.log_with"),xs=r(` to have it automatically
be used with the API:`),Da=p(),f(Ce.$$.fragment),La=p(),V=s("p"),Ds=r("These also can be mixed with existing trackers, including with "),Xt=s("code"),Ls=r('"all"'),Ss=r(":"),Sa=p(),f(Te.$$.fragment),za=p(),B=s("h2"),X=s("a"),Yt=s("span"),f(Pe.$$.fragment),zs=p(),Zt=s("span"),Ns=r("Accessing the internal tracker"),Na=p(),O=s("p"),Bs=r(`If some custom interactions with a tracker might be wanted directly, you can quickly access one using the
`),Qe=s("a"),Ms=r("Accelerator.get_tracker()"),Ws=r(" method. Just pass in the string corresponding to a tracker\u2019s "),ea=s("code"),Us=r(".name"),Fs=r(` attribute
and it will return that tracker on the main process.`),Ba=p(),Ve=s("p"),Gs=r("This example shows doing so with wandb:"),Ma=p(),f(Ie.$$.fragment),Wa=p(),x=s("p"),Rs=r("From there you can interact with "),ta=s("code"),Hs=r("wandb"),Js=r("\u2019s "),aa=s("code"),Ks=r("run"),Qs=r(" object like normal:"),Ua=p(),f(Oe.$$.fragment),Fa=p(),f(Y.$$.fragment),Ga=p(),Xe=s("p"),Vs=r(`If you want to truly remove Accelerate\u2019s wrapping entirely, you can
achieve the same outcome with:`),Ra=p(),f(xe.$$.fragment),Ha=p(),M=s("h2"),Z=s("a"),ra=s("span"),f(De.$$.fragment),Xs=p(),oa=s("span"),Ys=r("When a wrapper cannot work"),Ja=p(),D=s("p"),Zs=r("If a library has an API that does not follow a strict "),sa=s("code"),el=r(".log"),tl=r(" with an overall dictionary such as Neptune.AI, logging can be done manually under an "),la=s("code"),al=r("if accelerator.is_main_process"),rl=r(" statement:"),Ka=p(),f(Le.$$.fragment),this.h()},l(e){const i=Pn('[data-svelte="svelte-1phssyn"]',document.head);k=l(i,"META",{name:!0,content:!0}),i.forEach(a),C=d(e),q=l(e,"H1",{class:!0});var Se=n(q);W=l(Se,"A",{id:!0,class:!0,href:!0});var cl=n(W);lt=l(cl,"SPAN",{});var pl=n(lt);u(ae.$$.fragment,pl),pl.forEach(a),cl.forEach(a),yr=d(Se),nt=l(Se,"SPAN",{});var dl=n(nt);kr=o(dl,"Tracking"),dl.forEach(a),Se.forEach(a),da=d(e),re=l(e,"P",{});var ol=n(re);br=o(ol,`There are a large number of experiment tracking API\u2019s available, however getting them all to work with in a multi-processing environment can oftentimes be complex.
\u{1F917} Accelerate provides a general tracking API that can be used to log useful items during your script through `),ze=l(ol,"A",{href:!0});var hl=n(ze);$r=o(hl,"Accelerator.log()"),hl.forEach(a),ol.forEach(a),ha=d(e),L=l(e,"H2",{class:!0});var Va=n(L);U=l(Va,"A",{id:!0,class:!0,href:!0});var fl=n(U);it=l(fl,"SPAN",{});var ul=n(it);u(oe.$$.fragment,ul),ul.forEach(a),fl.forEach(a),Er=d(Va),ct=l(Va,"SPAN",{});var ml=n(ct);Ar=o(ml,"Integrated Trackers"),ml.forEach(a),Va.forEach(a),fa=d(e),F=l(e,"P",{});var Xa=n(F);jr=o(Xa,"Currently "),pt=l(Xa,"CODE",{});var _l=n(pt);qr=o(_l,"Accelerate"),_l.forEach(a),Cr=o(Xa," supports four trackers out-of-the-box:"),Xa.forEach(a),ua=d(e),$=l(e,"UL",{});var ee=n($);dt=l(ee,"LI",{});var gl=n(dt);Tr=o(gl,"TensorBoard"),gl.forEach(a),Pr=d(ee),ht=l(ee,"LI",{});var vl=n(ht);Ir=o(vl,"WandB"),vl.forEach(a),Or=d(ee),ft=l(ee,"LI",{});var wl=n(ft);xr=o(wl,"CometML"),wl.forEach(a),Dr=d(ee),ut=l(ee,"LI",{});var yl=n(ut);Lr=o(yl,"MLFlow"),yl.forEach(a),ee.forEach(a),ma=d(e),T=l(e,"P",{});var Ye=n(T);Sr=o(Ye,"To use any of them, pass in the selected type(s) to the "),mt=l(Ye,"CODE",{});var kl=n(mt);zr=o(kl,"log_with"),kl.forEach(a),Nr=o(Ye," parameter in "),_t=l(Ye,"CODE",{});var bl=n(_t);Br=o(bl,"Accelerate"),bl.forEach(a),Mr=o(Ye,":"),Ye.forEach(a),_a=d(e),u(se.$$.fragment,e),ga=d(e),G=l(e,"P",{});var Ya=n(G);Wr=o(Ya,"At the start of your experiment "),Ne=l(Ya,"A",{href:!0});var $l=n(Ne);Ur=o($l,"Accelerator.init_trackers()"),$l.forEach(a),Fr=o(Ya," should be used to setup your project, and potentially add any experiment hyperparameters to be logged:"),Ya.forEach(a),va=d(e),u(le.$$.fragment,e),wa=d(e),P=l(e,"P",{});var Ze=n(P);Gr=o(Ze,"When you are ready to log any data, "),Be=l(Ze,"A",{href:!0});var El=n(Be);Rr=o(El,"Accelerator.log()"),El.forEach(a),Hr=o(Ze,` should be used.
A `),gt=l(Ze,"CODE",{});var Al=n(gt);Jr=o(Al,"step"),Al.forEach(a),Kr=o(Ze," can also be passed in to correlate the data with a particular step in the training loop."),Ze.forEach(a),ya=d(e),u(ne.$$.fragment,e),ka=d(e),R=l(e,"P",{});var Za=n(R);Qr=o(Za,"Once you\u2019ve finished training, make sure to run "),Me=l(Za,"A",{href:!0});var jl=n(Me);Vr=o(jl,"Accelerator.end_training()"),jl.forEach(a),Xr=o(Za," so that all the trackers can run their finish functionalities if they have any."),Za.forEach(a),ba=d(e),u(ie.$$.fragment,e),$a=d(e),We=l(e,"P",{});var ql=n(We);Yr=o(ql,"A full example is below:"),ql.forEach(a),Ea=d(e),u(ce.$$.fragment,e),Aa=d(e),w=l(e,"P",{});var A=n(w);Zr=o(A,"If a tracker requires a directory to save data to such as "),vt=l(A,"CODE",{});var Cl=n(vt);eo=o(Cl,"TensorBoard"),Cl.forEach(a),to=o(A," then a "),wt=l(A,"CODE",{});var Tl=n(wt);ao=o(Tl,"logging_dir"),Tl.forEach(a),ro=o(A," or "),yt=l(A,"CODE",{});var Pl=n(yt);oo=o(Pl,"project_dir"),Pl.forEach(a),so=o(A," can be passed in. "),kt=l(A,"CODE",{});var Il=n(kt);lo=o(Il,"project_dir"),Il.forEach(a),no=o(A,` is useful
if there are other further configurations such as those which can be combined with the `),Ue=l(A,"A",{href:!0});var Ol=n(Ue);io=o(Ol,"ProjectConfiguration"),Ol.forEach(a),co=o(A," dataclass."),A.forEach(a),ja=d(e),u(pe.$$.fragment,e),qa=d(e),S=l(e,"H2",{class:!0});var er=n(S);H=l(er,"A",{id:!0,class:!0,href:!0});var xl=n(H);bt=l(xl,"SPAN",{});var Dl=n(bt);u(de.$$.fragment,Dl),Dl.forEach(a),xl.forEach(a),po=d(er),$t=l(er,"SPAN",{});var Ll=n($t);ho=o(Ll,"Implementing Custom Trackers"),Ll.forEach(a),er.forEach(a),Ca=d(e),I=l(e,"P",{});var et=n(I);fo=o(et,"To implement a new tracker to be used in "),Et=l(et,"CODE",{});var Sl=n(Et);uo=o(Sl,"Accelerator"),Sl.forEach(a),mo=o(et,", a new one can be made through implementing the "),At=l(et,"CODE",{});var zl=n(At);_o=o(zl,"GeneralTracker"),zl.forEach(a),go=o(et,` class.
Every tracker must implement three functions and have three properties:`),et.forEach(a),Ta=d(e),y=l(e,"UL",{});var j=n(y);he=l(j,"LI",{});var tr=n(he);Fe=l(tr,"P",{});var sl=n(Fe);jt=l(sl,"CODE",{});var Nl=n(jt);vo=o(Nl,"__init__"),Nl.forEach(a),wo=o(sl,":"),sl.forEach(a),yo=d(tr),fe=l(tr,"UL",{});var ar=n(fe);ue=l(ar,"LI",{});var rr=n(ue);ko=o(rr,"Should store a "),qt=l(rr,"CODE",{});var Bl=n(qt);bo=o(Bl,"run_name"),Bl.forEach(a),$o=o(rr," and initialize the tracker API of the integrated library."),rr.forEach(a),Eo=d(ar),me=l(ar,"LI",{});var or=n(me);Ao=o(or,"If a tracker stores their data locally (such as TensorBoard), a "),Ct=l(or,"CODE",{});var Ml=n(Ct);jo=o(Ml,"logging_dir"),Ml.forEach(a),qo=o(or," parameter can be added."),or.forEach(a),ar.forEach(a),tr.forEach(a),Co=d(j),_e=l(j,"LI",{});var sr=n(_e);Ge=l(sr,"P",{});var ll=n(Ge);Tt=l(ll,"CODE",{});var Wl=n(Tt);To=o(Wl,"store_init_configuration"),Wl.forEach(a),Po=o(ll,":"),ll.forEach(a),Io=d(sr),Pt=l(sr,"UL",{});var Ul=n(Pt);ge=l(Ul,"LI",{});var lr=n(ge);Oo=o(lr,"Should take in a "),It=l(lr,"CODE",{});var Fl=n(It);xo=o(Fl,"values"),Fl.forEach(a),Do=o(lr," dictionary and store them as a one-time experiment configuration"),lr.forEach(a),Ul.forEach(a),sr.forEach(a),Lo=d(j),ve=l(j,"LI",{});var nr=n(ve);Re=l(nr,"P",{});var nl=n(Re);Ot=l(nl,"CODE",{});var Gl=n(Ot);So=o(Gl,"log"),Gl.forEach(a),zo=o(nl,":"),nl.forEach(a),No=d(nr),xt=l(nr,"UL",{});var Rl=n(xt);z=l(Rl,"LI",{});var tt=n(z);Bo=o(tt,"Should take in a "),Dt=l(tt,"CODE",{});var Hl=n(Dt);Mo=o(Hl,"values"),Hl.forEach(a),Wo=o(tt," dictionary and a "),Lt=l(tt,"CODE",{});var Jl=n(Lt);Uo=o(Jl,"step"),Jl.forEach(a),Fo=o(tt,", and should log them to the run"),tt.forEach(a),Rl.forEach(a),nr.forEach(a),Go=d(j),we=l(j,"LI",{});var ir=n(we);J=l(ir,"P",{});var na=n(J);St=l(na,"CODE",{});var Kl=n(St);Ro=o(Kl,"name"),Kl.forEach(a),Ho=o(na," ("),zt=l(na,"CODE",{});var Ql=n(zt);Jo=o(Ql,"str"),Ql.forEach(a),Ko=o(na,"):"),na.forEach(a),Qo=d(ir),ye=l(ir,"UL",{});var cr=n(ye);ke=l(cr,"LI",{});var pr=n(ke);Vo=o(pr,"A unique string name for the tracker, such as "),Nt=l(pr,"CODE",{});var Vl=n(Nt);Xo=o(Vl,'"wandb"'),Vl.forEach(a),Yo=o(pr," for the wandb tracker."),pr.forEach(a),Zo=d(cr),Bt=l(cr,"LI",{});var Xl=n(Bt);es=o(Xl,"This will be used for interacting with this tracker specifically"),Xl.forEach(a),cr.forEach(a),ir.forEach(a),ts=d(j),be=l(j,"LI",{});var dr=n(be);K=l(dr,"P",{});var ia=n(K);Mt=l(ia,"CODE",{});var Yl=n(Mt);as=o(Yl,"requires_logging_directory"),Yl.forEach(a),rs=o(ia," ("),Wt=l(ia,"CODE",{});var Zl=n(Wt);os=o(Zl,"bool"),Zl.forEach(a),ss=o(ia,"):"),ia.forEach(a),ls=d(dr),Ut=l(dr,"UL",{});var en=n(Ut);$e=l(en,"LI",{});var hr=n($e);ns=o(hr,"Whether a "),Ft=l(hr,"CODE",{});var tn=n(Ft);is=o(tn,"logging_dir"),tn.forEach(a),cs=o(hr," is needed for this particular tracker and if it uses one."),hr.forEach(a),en.forEach(a),dr.forEach(a),ps=d(j),Ee=l(j,"LI",{});var fr=n(Ee);He=l(fr,"P",{});var il=n(He);Gt=l(il,"CODE",{});var an=n(Gt);ds=o(an,"tracker"),an.forEach(a),hs=o(il,":"),il.forEach(a),fs=d(fr),Ae=l(fr,"UL",{});var ur=n(Ae);je=l(ur,"LI",{});var mr=n(je);us=o(mr,"This should be implemented as a "),Rt=l(mr,"CODE",{});var rn=n(Rt);ms=o(rn,"@property"),rn.forEach(a),_s=o(mr," function"),mr.forEach(a),gs=d(ur),N=l(ur,"LI",{});var at=n(N);vs=o(at,"Should return the internal tracking mechanism the library uses, such as the "),Ht=l(at,"CODE",{});var on=n(Ht);ws=o(on,"run"),on.forEach(a),ys=o(at," object for "),Jt=l(at,"CODE",{});var sn=n(Jt);ks=o(sn,"wandb"),sn.forEach(a),bs=o(at,"."),at.forEach(a),ur.forEach(a),fr.forEach(a),j.forEach(a),Pa=d(e),Q=l(e,"P",{});var _r=n(Q);$s=o(_r,"Each method should also utilize the "),Je=l(_r,"A",{href:!0});var ln=n(Je);Es=o(ln,"state.PartialState"),ln.forEach(a),As=o(_r," class if the logger should only be executed on the main process for instance."),_r.forEach(a),Ia=d(e),Ke=l(e,"P",{});var nn=n(Ke);js=o(nn,`A brief example can be seen below with an integration with Weights and Biases, containing only the relevant information and logging just on
the main process:`),nn.forEach(a),Oa=d(e),u(qe.$$.fragment,e),xa=d(e),E=l(e,"P",{});var te=n(E);qs=o(te,"When you are ready to build your "),Kt=l(te,"CODE",{});var cn=n(Kt);Cs=o(cn,"Accelerator"),cn.forEach(a),Ts=o(te," object, pass in an "),Qt=l(te,"STRONG",{});var pn=n(Qt);Ps=o(pn,"instance"),pn.forEach(a),Is=o(te," of your tracker to "),Vt=l(te,"CODE",{});var dn=n(Vt);Os=o(dn,"Accelerator.log_with"),dn.forEach(a),xs=o(te,` to have it automatically
be used with the API:`),te.forEach(a),Da=d(e),u(Ce.$$.fragment,e),La=d(e),V=l(e,"P",{});var gr=n(V);Ds=o(gr,"These also can be mixed with existing trackers, including with "),Xt=l(gr,"CODE",{});var hn=n(Xt);Ls=o(hn,'"all"'),hn.forEach(a),Ss=o(gr,":"),gr.forEach(a),Sa=d(e),u(Te.$$.fragment,e),za=d(e),B=l(e,"H2",{class:!0});var vr=n(B);X=l(vr,"A",{id:!0,class:!0,href:!0});var fn=n(X);Yt=l(fn,"SPAN",{});var un=n(Yt);u(Pe.$$.fragment,un),un.forEach(a),fn.forEach(a),zs=d(vr),Zt=l(vr,"SPAN",{});var mn=n(Zt);Ns=o(mn,"Accessing the internal tracker"),mn.forEach(a),vr.forEach(a),Na=d(e),O=l(e,"P",{});var rt=n(O);Bs=o(rt,`If some custom interactions with a tracker might be wanted directly, you can quickly access one using the
`),Qe=l(rt,"A",{href:!0});var _n=n(Qe);Ms=o(_n,"Accelerator.get_tracker()"),_n.forEach(a),Ws=o(rt," method. Just pass in the string corresponding to a tracker\u2019s "),ea=l(rt,"CODE",{});var gn=n(ea);Us=o(gn,".name"),gn.forEach(a),Fs=o(rt,` attribute
and it will return that tracker on the main process.`),rt.forEach(a),Ba=d(e),Ve=l(e,"P",{});var vn=n(Ve);Gs=o(vn,"This example shows doing so with wandb:"),vn.forEach(a),Ma=d(e),u(Ie.$$.fragment,e),Wa=d(e),x=l(e,"P",{});var ot=n(x);Rs=o(ot,"From there you can interact with "),ta=l(ot,"CODE",{});var wn=n(ta);Hs=o(wn,"wandb"),wn.forEach(a),Js=o(ot,"\u2019s "),aa=l(ot,"CODE",{});var yn=n(aa);Ks=o(yn,"run"),yn.forEach(a),Qs=o(ot," object like normal:"),ot.forEach(a),Ua=d(e),u(Oe.$$.fragment,e),Fa=d(e),u(Y.$$.fragment,e),Ga=d(e),Xe=l(e,"P",{});var kn=n(Xe);Vs=o(kn,`If you want to truly remove Accelerate\u2019s wrapping entirely, you can
achieve the same outcome with:`),kn.forEach(a),Ra=d(e),u(xe.$$.fragment,e),Ha=d(e),M=l(e,"H2",{class:!0});var wr=n(M);Z=l(wr,"A",{id:!0,class:!0,href:!0});var bn=n(Z);ra=l(bn,"SPAN",{});var $n=n(ra);u(De.$$.fragment,$n),$n.forEach(a),bn.forEach(a),Xs=d(wr),oa=l(wr,"SPAN",{});var En=n(oa);Ys=o(En,"When a wrapper cannot work"),En.forEach(a),wr.forEach(a),Ja=d(e),D=l(e,"P",{});var st=n(D);Zs=o(st,"If a library has an API that does not follow a strict "),sa=l(st,"CODE",{});var An=n(sa);el=o(An,".log"),An.forEach(a),tl=o(st," with an overall dictionary such as Neptune.AI, logging can be done manually under an "),la=l(st,"CODE",{});var jn=n(la);al=o(jn,"if accelerator.is_main_process"),jn.forEach(a),rl=o(st," statement:"),st.forEach(a),Ka=d(e),u(Le.$$.fragment,e),this.h()},h(){h(k,"name","hf:doc:metadata"),h(k,"content",JSON.stringify(Ln)),h(W,"id","tracking"),h(W,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(W,"href","#tracking"),h(q,"class","relative group"),h(ze,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.log"),h(U,"id","integrated-trackers"),h(U,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(U,"href","#integrated-trackers"),h(L,"class","relative group"),h(Ne,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.init_trackers"),h(Be,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.log"),h(Me,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.end_training"),h(Ue,"href","/docs/accelerate/main/en/package_reference/utilities#accelerate.utils.ProjectConfiguration"),h(H,"id","implementing-custom-trackers"),h(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(H,"href","#implementing-custom-trackers"),h(S,"class","relative group"),h(Je,"href","/docs/accelerate/main/en/package_reference/state#accelerate.PartialState"),h(X,"id","accessing-the-internal-tracker"),h(X,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(X,"href","#accessing-the-internal-tracker"),h(B,"class","relative group"),h(Qe,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.get_tracker"),h(Z,"id","when-a-wrapper-cannot-work"),h(Z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Z,"href","#when-a-wrapper-cannot-work"),h(M,"class","relative group")},m(e,i){t(document.head,k),c(e,C,i),c(e,q,i),t(q,W),t(W,lt),m(ae,lt,null),t(q,yr),t(q,nt),t(nt,kr),c(e,da,i),c(e,re,i),t(re,br),t(re,ze),t(ze,$r),c(e,ha,i),c(e,L,i),t(L,U),t(U,it),m(oe,it,null),t(L,Er),t(L,ct),t(ct,Ar),c(e,fa,i),c(e,F,i),t(F,jr),t(F,pt),t(pt,qr),t(F,Cr),c(e,ua,i),c(e,$,i),t($,dt),t(dt,Tr),t($,Pr),t($,ht),t(ht,Ir),t($,Or),t($,ft),t(ft,xr),t($,Dr),t($,ut),t(ut,Lr),c(e,ma,i),c(e,T,i),t(T,Sr),t(T,mt),t(mt,zr),t(T,Nr),t(T,_t),t(_t,Br),t(T,Mr),c(e,_a,i),m(se,e,i),c(e,ga,i),c(e,G,i),t(G,Wr),t(G,Ne),t(Ne,Ur),t(G,Fr),c(e,va,i),m(le,e,i),c(e,wa,i),c(e,P,i),t(P,Gr),t(P,Be),t(Be,Rr),t(P,Hr),t(P,gt),t(gt,Jr),t(P,Kr),c(e,ya,i),m(ne,e,i),c(e,ka,i),c(e,R,i),t(R,Qr),t(R,Me),t(Me,Vr),t(R,Xr),c(e,ba,i),m(ie,e,i),c(e,$a,i),c(e,We,i),t(We,Yr),c(e,Ea,i),m(ce,e,i),c(e,Aa,i),c(e,w,i),t(w,Zr),t(w,vt),t(vt,eo),t(w,to),t(w,wt),t(wt,ao),t(w,ro),t(w,yt),t(yt,oo),t(w,so),t(w,kt),t(kt,lo),t(w,no),t(w,Ue),t(Ue,io),t(w,co),c(e,ja,i),m(pe,e,i),c(e,qa,i),c(e,S,i),t(S,H),t(H,bt),m(de,bt,null),t(S,po),t(S,$t),t($t,ho),c(e,Ca,i),c(e,I,i),t(I,fo),t(I,Et),t(Et,uo),t(I,mo),t(I,At),t(At,_o),t(I,go),c(e,Ta,i),c(e,y,i),t(y,he),t(he,Fe),t(Fe,jt),t(jt,vo),t(Fe,wo),t(he,yo),t(he,fe),t(fe,ue),t(ue,ko),t(ue,qt),t(qt,bo),t(ue,$o),t(fe,Eo),t(fe,me),t(me,Ao),t(me,Ct),t(Ct,jo),t(me,qo),t(y,Co),t(y,_e),t(_e,Ge),t(Ge,Tt),t(Tt,To),t(Ge,Po),t(_e,Io),t(_e,Pt),t(Pt,ge),t(ge,Oo),t(ge,It),t(It,xo),t(ge,Do),t(y,Lo),t(y,ve),t(ve,Re),t(Re,Ot),t(Ot,So),t(Re,zo),t(ve,No),t(ve,xt),t(xt,z),t(z,Bo),t(z,Dt),t(Dt,Mo),t(z,Wo),t(z,Lt),t(Lt,Uo),t(z,Fo),t(y,Go),t(y,we),t(we,J),t(J,St),t(St,Ro),t(J,Ho),t(J,zt),t(zt,Jo),t(J,Ko),t(we,Qo),t(we,ye),t(ye,ke),t(ke,Vo),t(ke,Nt),t(Nt,Xo),t(ke,Yo),t(ye,Zo),t(ye,Bt),t(Bt,es),t(y,ts),t(y,be),t(be,K),t(K,Mt),t(Mt,as),t(K,rs),t(K,Wt),t(Wt,os),t(K,ss),t(be,ls),t(be,Ut),t(Ut,$e),t($e,ns),t($e,Ft),t(Ft,is),t($e,cs),t(y,ps),t(y,Ee),t(Ee,He),t(He,Gt),t(Gt,ds),t(He,hs),t(Ee,fs),t(Ee,Ae),t(Ae,je),t(je,us),t(je,Rt),t(Rt,ms),t(je,_s),t(Ae,gs),t(Ae,N),t(N,vs),t(N,Ht),t(Ht,ws),t(N,ys),t(N,Jt),t(Jt,ks),t(N,bs),c(e,Pa,i),c(e,Q,i),t(Q,$s),t(Q,Je),t(Je,Es),t(Q,As),c(e,Ia,i),c(e,Ke,i),t(Ke,js),c(e,Oa,i),m(qe,e,i),c(e,xa,i),c(e,E,i),t(E,qs),t(E,Kt),t(Kt,Cs),t(E,Ts),t(E,Qt),t(Qt,Ps),t(E,Is),t(E,Vt),t(Vt,Os),t(E,xs),c(e,Da,i),m(Ce,e,i),c(e,La,i),c(e,V,i),t(V,Ds),t(V,Xt),t(Xt,Ls),t(V,Ss),c(e,Sa,i),m(Te,e,i),c(e,za,i),c(e,B,i),t(B,X),t(X,Yt),m(Pe,Yt,null),t(B,zs),t(B,Zt),t(Zt,Ns),c(e,Na,i),c(e,O,i),t(O,Bs),t(O,Qe),t(Qe,Ms),t(O,Ws),t(O,ea),t(ea,Us),t(O,Fs),c(e,Ba,i),c(e,Ve,i),t(Ve,Gs),c(e,Ma,i),m(Ie,e,i),c(e,Wa,i),c(e,x,i),t(x,Rs),t(x,ta),t(ta,Hs),t(x,Js),t(x,aa),t(aa,Ks),t(x,Qs),c(e,Ua,i),m(Oe,e,i),c(e,Fa,i),m(Y,e,i),c(e,Ga,i),c(e,Xe,i),t(Xe,Vs),c(e,Ra,i),m(xe,e,i),c(e,Ha,i),c(e,M,i),t(M,Z),t(Z,ra),m(De,ra,null),t(M,Xs),t(M,oa),t(oa,Ys),c(e,Ja,i),c(e,D,i),t(D,Zs),t(D,sa),t(sa,el),t(D,tl),t(D,la),t(la,al),t(D,rl),c(e,Ka,i),m(Le,e,i),Qa=!0},p(e,[i]){const Se={};i&2&&(Se.$$scope={dirty:i,ctx:e}),Y.$set(Se)},i(e){Qa||(_(ae.$$.fragment,e),_(oe.$$.fragment,e),_(se.$$.fragment,e),_(le.$$.fragment,e),_(ne.$$.fragment,e),_(ie.$$.fragment,e),_(ce.$$.fragment,e),_(pe.$$.fragment,e),_(de.$$.fragment,e),_(qe.$$.fragment,e),_(Ce.$$.fragment,e),_(Te.$$.fragment,e),_(Pe.$$.fragment,e),_(Ie.$$.fragment,e),_(Oe.$$.fragment,e),_(Y.$$.fragment,e),_(xe.$$.fragment,e),_(De.$$.fragment,e),_(Le.$$.fragment,e),Qa=!0)},o(e){g(ae.$$.fragment,e),g(oe.$$.fragment,e),g(se.$$.fragment,e),g(le.$$.fragment,e),g(ne.$$.fragment,e),g(ie.$$.fragment,e),g(ce.$$.fragment,e),g(pe.$$.fragment,e),g(de.$$.fragment,e),g(qe.$$.fragment,e),g(Ce.$$.fragment,e),g(Te.$$.fragment,e),g(Pe.$$.fragment,e),g(Ie.$$.fragment,e),g(Oe.$$.fragment,e),g(Y.$$.fragment,e),g(xe.$$.fragment,e),g(De.$$.fragment,e),g(Le.$$.fragment,e),Qa=!1},d(e){a(k),e&&a(C),e&&a(q),v(ae),e&&a(da),e&&a(re),e&&a(ha),e&&a(L),v(oe),e&&a(fa),e&&a(F),e&&a(ua),e&&a($),e&&a(ma),e&&a(T),e&&a(_a),v(se,e),e&&a(ga),e&&a(G),e&&a(va),v(le,e),e&&a(wa),e&&a(P),e&&a(ya),v(ne,e),e&&a(ka),e&&a(R),e&&a(ba),v(ie,e),e&&a($a),e&&a(We),e&&a(Ea),v(ce,e),e&&a(Aa),e&&a(w),e&&a(ja),v(pe,e),e&&a(qa),e&&a(S),v(de),e&&a(Ca),e&&a(I),e&&a(Ta),e&&a(y),e&&a(Pa),e&&a(Q),e&&a(Ia),e&&a(Ke),e&&a(Oa),v(qe,e),e&&a(xa),e&&a(E),e&&a(Da),v(Ce,e),e&&a(La),e&&a(V),e&&a(Sa),v(Te,e),e&&a(za),e&&a(B),v(Pe),e&&a(Na),e&&a(O),e&&a(Ba),e&&a(Ve),e&&a(Ma),v(Ie,e),e&&a(Wa),e&&a(x),e&&a(Ua),v(Oe,e),e&&a(Fa),v(Y,e),e&&a(Ga),e&&a(Xe),e&&a(Ra),v(xe,e),e&&a(Ha),e&&a(M),v(De),e&&a(Ja),e&&a(D),e&&a(Ka),v(Le,e)}}}const Ln={local:"tracking",sections:[{local:"integrated-trackers",title:"Integrated Trackers"},{local:"implementing-custom-trackers",title:"Implementing Custom Trackers"},{local:"accessing-the-internal-tracker",title:"Accessing the internal tracker "},{local:"when-a-wrapper-cannot-work",title:"When a wrapper cannot work"}],title:"Tracking"};function Sn(pa){return In(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Wn extends qn{constructor(k){super();Cn(this,k,Sn,Dn,Tn,{})}}export{Wn as default,Ln as metadata};
